
extends Panel

# member variables here, example:
# var a=2
# var b="textvar"


var enemy_names=["evil","fowlers","icecubes","rollings","tanneds","unibrownies"]
var level_names=["endless","challenge","wooden","chinese","lab","garage"]

var Obstacles = preload("obstacles.gd")
var dialog=null
var match=null

func _on_open_pressed():
	dialog.clear_filters()
	dialog.add_filter("*.lvl")
	dialog.set_mode( FileDialog.MODE_OPEN_FILE )
	dialog.popup_centered_ratio()

func _on_endless_pressed():
	dialog.clear_filters()
	dialog.add_filter("*.txt")
	dialog.set_mode( FileDialog.MODE_OPEN_FILE )
	dialog.popup_centered_ratio()

func _on_save_pressed():
	dialog.set_mode( FileDialog.MODE_SAVE_FILE )
	dialog.popup_centered_ratio()

func _on_back_to_editor_pressed():
	match.queue_free()
	show()
	
func _on_play_pressed():
	var s = ResourceLoader.load("res://match/match.xml")
	match=s.instance()
	var d = {}
	d["formation"]=get_node("formation").level
	d["level"]=get_node("level").level
	d["opponents"]=enemy_names[get_node("opponents").get_selected()]
	d["field"]=level_names[get_node("field").get_selected()]
	
	match.load_level_data(d)
	match.get_node("editor").connect("pressed",self,"_on_back_to_editor_pressed")
	get_parent().add_child(match)
	hide()

func _on_file_selected(file):
	if (dialog.get_mode()==FileDialog.MODE_OPEN_FILE):
		if (file.find(".txt")!=-1): # opening endless

			var s = ResourceLoader.load("res://match/match.xml")
			match=s.instance()			
			match.load_endless(file)
			match.get_node("editor").connect("pressed",self,"_on_back_to_editor_pressed")
			get_parent().add_child(match)
			hide()
		
		else:
			var f = File.new()
			var err = f.open(file,File.READ)
			if (err):
				print("Could not open: ",file)
				return
			var d = f.get_var()
			get_node("formation").level=d["formation"]
			get_node("formation").update()
			get_node("level").level=d["level"]
			get_node("level").update()
			if (d.has("opponents")):
				var op = d["opponents"]
				var idx = enemy_names.find(op)
				if (idx!=-1):
					get_node("opponents").select(idx)
				
			if (d.has("field")):
				var fi = d["field"]
				var idx = level_names.find(fi)
				if (idx!=-1):
					get_node("field").select(idx)
			
	else:
		var f = File.new()
		var err = f.open(file,File.WRITE)
		if (err):
			print("Could not open: ",file)
			return
		var d = {}
		d["formation"]=get_node("formation").level
		d["level"]=get_node("level").level
		d["opponents"]=enemy_names[get_node("opponents").get_selected()]
		d["field"]=level_names[get_node("field").get_selected()]
		f.store_var(d)
		
		

func _on_cell_selected():
	var ss= get_node("proplist").get_selected()
	get_node("level").selected_item=ss.get_metadata(0)
	
	

func _ready():
	# Initalization here
	
	var t = get_node("proplist")
	t.set_hide_root(true)
	var r = t.create_item(null)
	print("item max", Obstacles.ITEM_MAX)
	for i in range(Obstacles.ITEM_MAX):
		var it = t.create_item(r)
		it.set_icon(0,Obstacles.images[i])
		it.set_text(0,Obstacles.names[i])
		it.set_metadata(0,i)
	
	get_node("formation").selected_item=Obstacles.PLAYER
	dialog=get_node("dialog")
	dialog.connect("file_selected",self,"_on_file_selected")
	
	for x in enemy_names:
		get_node("opponents").add_item(x)
	for x in level_names:
		get_node("field").add_item(x)
	
	
	pass


