
extends ReferenceFrame

# member variables here, example:
# var a=2
# var b="textvar"


const GRID_SIZE = 32
const GRID_COUNT = 4

var Obstacles = preload("obstacles.gd")

var level={}

var scroll=null

var selected_item=0


func _scroll_changed(value):
	update()

func _input_event(ev):
	if (ev.type==InputEvent.MOUSE_BUTTON and ev.pressed):
		var pos = (ev.pos / GRID_SIZE)
		pos.x = floor(pos.x)
		pos.y = floor(pos.y)
		if (selected_item==Obstacles.BARRIER):
			pos.y=0
		if (scroll):
			pos.x+=floor(scroll.get_value())		
		print("pos: ",pos)
		if (pos.y<0 or pos.y >= GRID_COUNT):
			return
		if (pos.x<0):
			return
		if (ev.button_index==1):
			level[pos]=selected_item
		elif (ev.button_index==2):
			level.erase(pos)
		
		update()
		

func _draw():


	var so = 0
	if (scroll):
		so=floor(scroll.get_value())

	var f = get_font("font","Label")
	var hc = int(get_size().width/GRID_SIZE)
	draw_rect(Rect2(Vector2(),get_size()),Color(1,1,1))
	for i in range(GRID_COUNT):
		draw_line(Vector2(0,GRID_SIZE*(i+1)),Vector2(hc*(GRID_SIZE),GRID_SIZE*(i+1)),Color(0,0,0))
	for i in range(hc):
		draw_line(Vector2(GRID_SIZE*(i+1),0),Vector2(GRID_SIZE*(i+1),GRID_SIZE*(GRID_COUNT)),Color(0,0,0))
		draw_string(f,Vector2(GRID_SIZE*(i+1)-GRID_SIZE,GRID_SIZE*(GRID_COUNT)+f.get_ascent()+2),str(i+so+1),Color(0,0,0))
	
	
	
	for x in range(hc):
		for y in range(GRID_COUNT):
			var p = Vector2(x+so,y)
			if (level.has(p)):
				draw_texture( Obstacles.images[level[p]], (Vector2(p.x-so,p.y))*GRID_SIZE)
	
	
	

func _ready():
	# Initalization here
	if (has_node("scroll")):
		scroll=get_node("scroll")
		scroll.connect("value_changed",self,"_scroll_changed")
		
	


	pass


