
extends Node

const Achievements = preload("res://config/achievements.gd")

const POWERUP_EVADE = 0
const POWERUP_BULLETTIME = 1
const POWERUP_FREEZE = 2
const POWERUP_CHEER = 3
const POWERUP_SUPERBALL = 4
const POWERUP_MAX = 5 # update this

const POWERUP_STATUS_DISABLED = -1
const POWERUP_STATUS_ENABLED = 0
const POWERUP_STATUS_UPGRADE1 = 1
const POWERUP_STATUS_UPGRADE2 = 2
const POWERUP_STATUS_UPGRADE3 = 3

const MODE_LEVEL = 0
const MODE_ENDLESS = 1
const MODE_CHALLENGE = 2

const save_filename = "user://.metegol_state.sav"

var values = {
	"coins": 1000, #Globals.get("initial_coins"),
	"powerups_available": Globals.get("powerups_available"),
	"music_disabled": false,
	"sound_disabled": false,
	"current_powerup": 0,
	"unlocked_level": 0,
	"wins_in_a_row":0,
	"endless_played":0,
	"language":"en",
	"beto_mode":false,
	"last_lost_level":-1,
	"training_high_score": 0,
	"high_detail": false, #(OS.get_processor_count()>=2),
	"noblex_mode":false,
#	"features": { "challenge_unlock":true,"powerup_unlock":true },
	"features": { },
	"saw_items": false,
	"challenges_created":0,
	"challenges_solved":0,
	"achievements":[],
	"powerup_status": [-1,-1,-1,-1,-1],
	"game_packages_bought": [],
	"store_packages_bought": [],
}

var result = {	
	"passes":0,
	"coins":0,
	"meters":0,
	"mode":MODE_LEVEL,	
	"goalkeeped":false,
	"win":true,
	"stars":0,
	"goaled":false	
}


const easy_completed = 29

var levels = [
#garage
	"res://levels/story_mode/passing.lvl",
	"res://levels/story_mode/level_02.lvl",
	"res://levels/story_mode/level_01.lvl",
	"res://levels/story_mode/level_03.lvl",
	"res://levels/story_mode/bonus_head_01.lvl",
#wooden
	"res://levels/story_mode/level_04.lvl",
	"res://levels/story_mode/level_05.lvl",
	"res://levels/story_mode/level_06.lvl",
	"res://levels/story_mode/level_07.lvl",
	"res://levels/story_mode/level_08.lvl",
	"res://levels/story_mode/bonus_finger_01.lvl",
#chinese
	"res://levels/story_mode/level_09.lvl",
	"res://levels/story_mode/level_10.lvl",
	"res://levels/story_mode/level_11.lvl",
	"res://levels/story_mode/level_12.lvl",
	"res://levels/story_mode/level_13.lvl",
	"res://levels/story_mode/level_14.lvl",
	"res://levels/story_mode/bonus_head_02.lvl",
#lab
	"res://levels/story_mode/level_15.lvl",
	"res://levels/story_mode/level_16.lvl",
	"res://levels/story_mode/level_17.lvl",
	"res://levels/story_mode/level_18.lvl",
	"res://levels/story_mode/bonus_finger_02.lvl",
#feria
	"res://levels/story_mode/level_19.lvl",
	"res://levels/story_mode/level_20.lvl",
	"res://levels/story_mode/level_21.lvl",
	"res://levels/story_mode/level_22.lvl",
	"res://levels/story_mode/level_23.lvl",
	"res://levels/story_mode/bonus_head_03.lvl",
#hard_garage
	"res://levels/story_mode/level_25.lvl",
	"res://levels/story_mode/level_26.lvl",
	"res://levels/story_mode/level_27.lvl",
	"res://levels/story_mode/level_28.lvl",
	"res://levels/story_mode/level_29.lvl",
	"res://levels/story_mode/bonus_finger_03.lvl",
#hard_wooden
	"res://levels/story_mode/level_30.lvl",
	"res://levels/story_mode/level_31.lvl",
	"res://levels/story_mode/level_32.lvl",
	"res://levels/story_mode/level_33.lvl",
	"res://levels/story_mode/level_35.lvl",
	"res://levels/story_mode/bonus_head_04.lvl",
#hard_chinese
	"res://levels/story_mode/level_34.lvl",
	"res://levels/story_mode/level_36.lvl",
	"res://levels/story_mode/level_37.lvl",
	"res://levels/story_mode/level_38.lvl",
	"res://levels/story_mode/level_39.lvl",
	"res://levels/story_mode/bonus_finger_04.lvl",
#hard_lab
	"res://levels/story_mode/level_40.lvl",
	"res://levels/story_mode/level_41.lvl",
	"res://levels/story_mode/level_42.lvl",
	"res://levels/story_mode/level_43.lvl",
	"res://levels/story_mode/level_44.lvl",
	"res://levels/story_mode/bonus_head_05.lvl",
#hard_feria
	"res://levels/story_mode/level_45.lvl",
	"res://levels/story_mode/level_46.lvl",
	"res://levels/story_mode/level_47.lvl",
	"res://levels/story_mode/level_48.lvl",
	"res://levels/story_mode/bonus_finger_05.lvl",
	
]


func set_powerups(pu):
	values["powerup_status"] = pu

func get_powerups():
	return values["powerup_status"]

func get_powerup(idx):	
	return values["powerup_status"][idx]

func get_cospels():
	return values["coins"]


func set_cospels(amount):
	values["coins"] = amount

func set_value(name, val):
	assert( name in values )
	values[name] = val

func get_value(name):
	assert( name in values )
	if name in values:
		return values[name]
	else:
		return null

func has_value(name):
	return name in values

func save():
	var f = File.new()
	f.open(save_filename, File.WRITE)
	f.store_var(values)
	
	# save
	pass

func load():
	# load
	var f = File.new()
	var err = f.open(save_filename, File.READ)
	if (err==OK):
		var tmp_values = f.get_var()
		for v in tmp_values:
			values[v]=tmp_values[v]
			
		while(values["achievements"].size() < Achievements.ACH_MAX):
			values["achievements"].push_back(false)
		
		TranslationServer.set_locale(values["language"])
	else:
		print("NO SAVEDATA, KEEPING DEFAULTS")
		#load_defaults()


func unlock_achievement(idx):
	var a = values["achievements"]
	if (a[idx]):
		return #already has
	a[idx]=true
	if OS.get_name() == "QNX":
		var prefix = Globals.get("QNX/achievement_prefix")
		var sl = Globals.get_singleton("Scoreloop")
		var aid = "achievement_title_"+str(idx+1)
		sl.award_achievement({ "name": prefix+aid } )

	if OS.get_name() == "iOS":
		var prefix = Globals.get("iOS/achievement_prefix")
		var gc = Globals.get_singleton("GameCenter")
		var aid = "achievement_title_"+str(idx+1)
		gc.award_achievement( { "name": aid, "progress": 100 } )

		var sl = Globals.get_singleton("Scoreloop")
		sl.award_achievement({ "name": prefix+aid } )


func clear_progress():

	values["current_powerup"]= 0
	values["unlocked_level"]= 0
	values["wins_in_a_row"]=0
	values["endless_played"]=0
	values["last_lost_level"]=-1
#	values["powerup_status"]= [-1,-1,-1,-1,-1]
	save()

	

func _init():


	var l = OS.get_locale().substr(0,2)
	if (not l in ["es","en","it","fr","pt","ru","kr","cn"]):
		l="en"
	print("OS language: ",l)
	print("DEVICE: ",OS.get_model_name())
	if (OS.get_model_name().find("NBX")==0):
		values["noblex_mode"]=true
	values["language"]=l
	for i in range(Achievements.ACH_MAX):
		values.achievements.push_back( false )
	load()

	if (values["noblex_mode"]):
		values["coins"]=10000000

	if Globals.has_singleton("Scoreloop"):
		Globals.get_singleton("Scoreloop").connect(Globals.get("scoreloop/game_secret"))
