
extends TextureFrame

var Achievements = preload("res://config/achievements.gd")

# member variables here, example:
# var a=2
# var b="textvar"

func _enter_scene():

	var gs = get_scene().get_root().get_node("gamestate")
	var vbc = VBoxContainer.new()
	get_node("list").add_child(vbc)
	get_node("best/distance").set_text(str( gs.get_value("training_high_score") ) )

	for i in range(Achievements.ACH_MAX):
		var item = preload("res://screens/achiev_item.xml").instance()
		item.get_node("name").set_text("ACHIEVEMENT_TITLE_"+str(i+1))
		item.get_node("description").set_text("ACHIEVEMENT_DESCRIPTION_"+str(i+1))
		var active = gs.get_value("achievements")[i]
		if (active):
			item.get_node("disabled").hide()
		else:
			item.get_node("disabled").show()
		vbc.add_child(item)
			
	get_node("list").set_theme(preload("res://screens/scrolls.xml"))
	get_node("list").set_enable_h_scroll(false)
		
	if (OS.get_name()=="QNX" || OS.get_name()=="Android"):
		get_node("scoreloop").show()	
	

	# Initalization here
	pass




func _on_back_pressed():
	get_scene().call_group(0, "global", "change_scene", "res://screens/main.xml")
	pass


func _on_scoreloop_pressed():
	if OS.get_name() == "Android":
		Globals.get_singleton("Scoreloop").show_ui()
	else:
		get_scene().call_group(0, "global", "change_scene", "res://screens/sl_leaderboards.xml")
	
