
var list
var Scoreloop
var base_item
var current = null

func back():
	get_scene().call_group(0, "global", "change_scene", "res://screens/main.xml")

func start_pressed():
	get_scene().call_group(0, "global", "change_scene", "res://screens/challenge_editor.xml")

func item_selected(event, p_item, id):
	if event.type != InputEvent.MOUSE_BUTTON || !event.pressed:
		return
	for i in range(list.get_child_count()):
		var it = list.get_child(i)
		if it == p_item:
			it.get_node("selected").show()
		else:
			it.get_node("selected").hide()
	if typeof(current) != typeof(null) && current == id:
		play_pressed()
	current = id

func load_challenge_list(event):
	print("*** challenge list ", event.ids.size())
	while list.get_child_count() > 0:
		list.remove_child(list.get_child(0))

	for i in range(0, event.ids.size()):
		var item = base_item.duplicate()
		item.get_node("name").set_text(event.users[i])
		item.connect("input_event", self, "item_selected", [item, event.ids[i]])
		item.show()
		if i == 0:
			item.get_node("selected").show()
		else:
			item.get_node("selected").hide()
		list.add_child(item)

	if event.ids.size() == 0:
		get_node("list_container/list_empty").show()
	else:
		get_node("list_container/list_empty").hide()
	get_node("animation").play("ready")


func check_events():
	while Scoreloop.get_pending_event_count() > 0:
		var event = Scoreloop.pop_pending_event()
		printt("got event!", event.type, event.result)
		if event.type == "challenges":
			if event.result == "ok":
				load_challenge_list(event)
			else:
				get_node("list_container/list_empty").show()

			get_node("animation").play("ready")

func play_pressed():
	if !Globals.has_singleton("Scoreloop"):
		return
	if typeof(current) == typeof(null):
		return
	var cur = current
	var ctx = Scoreloop.get_challenge_context(cur)
	printt("selected ", current, ctx.level)
	var level = Marshalls.base64_to_variant(ctx.level)
	printt("level is ", level)
	Globals.set("current_level", { "type": "challenge", "level": level, "mode": "remote", "challenge_id": cur } )
	get_scene().call_group(0, "global", "change_scene", "res://match/match.xml")


func _ready():
	get_node("main").connect("pressed", self, "back")
	get_node("start").connect("pressed", self, "start_pressed")

	list = get_node("scroll/vbox")
	base_item = get_node("item")
	base_item.hide()

	get_node("list_container/list_empty").hide()

	if !Globals.has_singleton("Scoreloop"):
		call_deferred("load_challenge_list", { "ids": ["1","2","3","4"], "users": ["Jake the dog", "Finn the human", "The fun will never end", "it's Adventure Time :D"] } )
		return

	Scoreloop = Globals.get_singleton("Scoreloop")
	var ret = Scoreloop.load_challenges()
	get_node("play").connect("pressed", self, "play_pressed")

	if ret != OK:
		get_node("list_container/list_empty").show()
	else:
		get_node("animation").play("busy")

	var timer = get_node("timer")
	timer.set_wait_time(1)
	timer.set_one_shot(false)
	timer.connect("timeout", self, "check_events")
	timer.start()

