export var max_columns = 16

var current_enemy = 0
var field = {}
var cells = []
var store

var Obstacles = preload("res://editor/obstacles.gd")

var max_move_dist_sq = 20
var mouse_move_dist_sq = null

func cell(x, y):
	return y * max_columns + x

func cell_pos(n):
	var x = n % max_columns
	var y = floor(n / max_columns)
	return Vector2(x, y)

func enemy_pressed(enemy):
	current_enemy = enemy

func cell_used(x, y):
	# check if cell is usable
	var n = cell(x, y)
	if n in field && field[n] == current_enemy:
		field[n] = null
	else:
		field[n] = current_enemy
	cell_changed(n)

func cell_changed(n):
	while cells[n].get_child_count() > 0:
		cells[n].remove_child(cells[n].get_child(0))
	var sp
	if n in field && typeof(field[n]) != typeof(null):
		sp = Obstacles.images[field[n]]
	else:
		sp = preload("res://editor/empty.png")

	var sprite = Sprite.new()
	sprite.set_texture(sp)
	sprite.set_centered(false)
	cells[n].add_child(sprite)

func cell_input(event, x, y):
	if event.type == InputEvent.MOUSE_BUTTON:
		if event.pressed:
			mouse_move_dist_sq = 0
		else:
			if mouse_move_dist_sq < max_move_dist_sq:
				cell_used(x, y)
			mouse_move_dist_sq = null

	if event.type == InputEvent.MOUSE_MOTION && typeof(mouse_move_dist_sq) != typeof(null):
		mouse_move_dist_sq += Vector2(event.relative_x, event.relative_y).length_squared()


func buy_more_pressed():
	store = preload("res://screens/store.xml").instance()
	hide()
	get_scene().get_root().add_child(store)

func store_back():
	show()
	store.queue_free()
	update_features_available()

func update_features_available():
	pass

func send_pressed():
	var level = { "level": {}, "formation": [ Vector2(0, 0), Vector2(0, 1), Vector2(0, 2), Vector2(0, 3) ] }
	for key in field.keys():
		var pos = cell_pos(key)
		pos.x = pos.x * 2
		level.level[pos] = field[key]
	Globals.set("current_level", { "type": "challenge", "level": level, "mode": "local" } )
	get_scene().call_group(0, "global", "change_scene", "res://screens/pre_game.xml")

func _mode_pressed(idx):
	get_node("field/field_draw").set_pen(idx)
	for i in range(8):
		var n = get_node("enemy_types/button "+str(i+1)+"/anim")
		if (i==idx):
			n.play("enabled")
		else:
			n.play("disabled")
		

func _ready():

#	get_node("list").set_enable_h_scroll(false)
	get_node("field").set_theme(preload("res://screens/scrolls.xml"))


	for i in range(8):
		var n = get_node("enemy_types/button "+str(i+1))
		n.connect("pressed",self,"_mode_pressed",[i])
		
	_mode_pressed(0)
		
	return
	var field = get_node("field/vbox")
	var cell = field.get_node("row 0/cell")

	for i in range(0, field.get_child_count()):

		var row = field.get_child(i)

		while row.get_child_count() < max_columns:
			var ncell = cell.duplicate()
			row.add_child(ncell)

		for j in range(0, row.get_child_count()):
			var cell = row.get_child(j)
			cells.push_back(cell)
			cell.set_stop_mouse(false)
			cell.connect("input_event", self, "cell_input", [j, i])
			cell_changed(cell(j, i))

	var enemies = get_node("tabs/enemies/enemies")
	for i in range(0, enemies.get_child_count()):
		var but = enemies.get_child(i)
		but.connect("pressed", self, "enemy_pressed", [i])
		but.set_normal_texture(Obstacles.images[i])

	get_node("buy_more").connect("pressed", self, "buy_more_pressed")

	add_to_group("store_actions")

	get_node("send").connect("pressed", self, "send_pressed")

	update_features_available()
