
extends EmptyControl

# member variables here, example:
# var a=2
# var b="textvar"

const EXTRA_BUY_TILES = 2
const PEN_ERASE = 7

var light = preload("res://screens/challenge/grid_light.png")
var dark = preload("res://screens/challenge/grid_dark.png")
var ultradark = preload("res://screens/challenge/grid_ultradark.png")
var length
var pen = 0

var stage={}

var cell_types=[
	preload("res://screens/challenge/cell_walk.png"),
	preload("res://screens/challenge/cell_run.png"),
	preload("res://screens/challenge/cell_slide.png"),
	preload("res://screens/challenge/cell_zigzag.png"),
	preload("res://screens/challenge/cell_shark.png"),
	preload("res://screens/challenge/cell_stopper.png"),
	preload("res://screens/challenge/cell_cone.png")
]




func _draw():
	var cofs = (light.get_size() - cell_types[0].get_size())/2
	for i in range(length+EXTRA_BUY_TILES):
		for j in range(4):
			var tile
			if (i>=length):
				tile=[dark,ultradark][((i&1)^(j&1))]
			else:
				tile=[light,dark][((i&1)^(j&1))]
			var pos = Vector2(i,j)*tile.get_size()
			draw_texture(tile,pos)
			
			var cellpos = Vector2(i,j)
			if (stage.has(cellpos)):
				draw_texture(cell_types[ stage[cellpos] ],pos+cofs)

var mlen=Vector2()

func _input_event(ev):

	if (ev.type==InputEvent.MOUSE_MOTION):
		mlen+=ev.relative_pos

	if (ev.type==InputEvent.MOUSE_BUTTON):
	
		if (ev.pressed):
			mlen=Vector2()
		elif (mlen.length() <5):
			var pos = ev.pos / light.get_size()
			pos = Vector2(floor(pos.x),floor(pos.y))
			if (pos.x<0 or pos.x>=length or pos.y<0 or pos.y>=4):
				return
			if (pen==PEN_ERASE):
				stage.erase(pos)
			else:
				stage[pos]=pen
				get_node("../../../sfx").play("click")
	
			update()

func set_pen(ptype):
	pen=ptype

func set_length(len):
	set_minsize(light.get_size()*Vector2(len+EXTRA_BUY_TILES,4))
	length=len
	update()
	var bm = get_node("buy_more")
	bm.set_pos( Vector2(length,1)*light.get_size() )

func _ready():
	# Initalization here
	set_length(20)
	

	pass


