extends Control

var store
var game
var powerups=[]
var can_always_buy_powerups=false
var Achievements = preload("res://config/achievements.gd")

var config = preload("res://config/game_config.gd")
var pu_names=["gambeta","bullet_time","freeze","vuvuzela","bola"]

func back():
	print("gear up back pressed!")
	get_scene().call_group(0, "gear_up_actions", "gear_up_cancel")

func store_powerups():
	pass

func play():
	store_powerups()
	Globals.set("current_level",{"type":"level","level":game.get_value("unlocked_level")})
	get_scene().call_group(0, "gear_up_actions", "gear_up_done")
	
	

func store_pressed():
	store = preload("res://screens/store.xml").instance()
	hide()
	get_parent().add_child(store)

func item_toggled( item):

	get_node("sfx").play("select")
	var pu_status = game.get_value("powerup_status")
	for i in range(5):
		
		var status = pu_status[i]
		if (status>=0 and item == i):
			powerups[i].set_pressed(true)
		else:
			powerups[i].set_pressed(false)
			
	game.set_value("current_powerup",item)
	game.save()

func update_coins():
	get_node("coins").set_number(game.get_cospels())

func store_back():
	show()
	store.queue_free()
	#update_upgrades()
	update_status()

func upgrade_item(item):

	var pu_status = game.get_value("powerup_status")
	
	if (pu_status[item]<0):
		#unlock		
		var price = config.get("powerup_"+str(item+1)+"_price")
		if (price > game.get_cospels()):
			#not enough munny, show sign or something
			get_node("/root/global").popup_dialog(tr("NOTIFICATION_COINS_TITLE"),tr("NOTIFICATION_COINS"),tr("NOTIFICATION_COINS_STORE"),null,null,"",false)
			get_node("/root/global/sfx").play("error")
			return
		
		game.set_cospels( game.get_cospels() - price )
		pu_status[item]=0
		powerups[item].get_node("chains").set_emitting(true)
		powerups[item].get_node("fire").set_emitting(true)
		get_node("sfx").play("unlock")

		game.set_value("current_powerup",item)
		Flurry.log_event("PG_UI_BUY_POWERUP",{"which":item})
		
	elif (pu_status[item]<2):
		#improve
		var price = config.get("powerup_"+str(item+1)+"_upgrade_"+str(pu_status[item]+1)+"_price")
		
		if (price > game.get_cospels()):
			#not enough munny, show sign or something
			get_node("/root/global").popup_dialog(tr("NOTIFICATION_COINS_TITLE"),tr("NOTIFICATION_COINS"),tr("NOTIFICATION_COINS_STORE"),null,null,"",false)
			get_node("/root/global/sfx").play("error")
			return
				
		game.set_cospels( game.get_cospels() - price )
		pu_status[item]+=1
		game.set_value("current_powerup",item)
		powerups[item].get_node("shine").set_emitting(true)
		get_node("sfx").play("upgrade")
		Flurry.log_event("PG_UI_UPGRADE_POWERUP",{"which":item,"to_level":pu_status[item]})
		
		var a = game.get_value("achievements")
		if (not a[Achievements.ACH_ALL_POWERUP_MAX_LEVEL]):
			var all_max=true
			for s in pu_status:
				if (s!=2):
					all_max=false
			if (all_max):
					var title =tr("ACHIEVEMENT_UNLOCKED")
					var which = Achievements.ACH_ALL_POWERUP_MAX_LEVEL
					var subtitle="#"+str(int(which+1))#tr("ACHIEVEMENT_TITLE_"+str(which+1))
					var text=tr("ACHIEVEMENT_DESCRIPTION_"+str(which+1))
					var icon=preload("res://screens/achievements/coin_achievements.png")
					get_node("/root/global").popup_dialog(title,subtitle,text,icon)
					game.unlock_achievement(Achievements.ACH_ALL_POWERUP_MAX_LEVEL)




		
		
		var achiev_all_max=false

	update_status()
	game.save()	
		

func update_status():
	print("powerups: : ",game.get_powerups())

	var pu_status = game.get_powerups()
	var level = game.get_value("unlocked_level")
	get_node("level/number").set_text(tr("GEAR_UP_LEVEL")+" "+str(level))
	
	for i in range(powerups.size()):
		var pu = powerups[i]
		var upgradeb = pu.get_node("upgrade")
		var price = pu.get_node("price/number")
		var upgrade = pu.get_node("upgrade/text")
		
		var status = pu_status[i]

		if (status==-1):
			 #disabled, can buy?
			var unlock_level = config.get("powerup_"+str(i+1)+"_unlock_level")
			
			if (not can_always_buy_powerups and level<unlock_level and not game.get_value("noblex_mode")):
				pu.set_disabled(true)
				upgradeb.set_disabled(true)
				upgrade.set_text(tr("GEAR_UP_LEVEL")+" "+str(unlock_level)+"+")
				price.set_text("--")
				pu.set_disabled_texture(ResourceLoader.load("res://screens/gear_up/"+pu_names[i]+"_disabled.png"))
				
			else:
				pu.set_disabled(true)
				upgradeb.set_disabled(false)
				upgrade.set_text(tr("GEAR_UP_BUY"))
				price.set_text(str(config.get("powerup_"+str(i+1)+"_price")))
				pu.set_disabled_texture(ResourceLoader.load("res://screens/gear_up/"+pu_names[i]+"_locked.png"))
		elif (status<2):
				pu.set_disabled(false)
				upgradeb.set_disabled(false)
				upgrade.set_text(tr("GEAR_UP_UPGRADE"))
				price.set_text(str(config.get("powerup_"+str(i+1)+"_upgrade_"+str(status+1)+"_price")))
		else:
				pu.set_disabled(false)
				upgradeb.set_disabled(true)
				upgrade.set_text("")
				price.set_text("--")

		for i in range(3):
			if (status<=0):
				pu.get_node("upgrade 1").hide()
			else:
				pu.get_node("upgrade 1").show()

			if (status<2):
				pu.get_node("upgrade 2").hide()
			else:
				pu.get_node("upgrade 2").show()

			if (status<3):
				pu.get_node("upgrade 3").hide()
			else:
				pu.get_node("upgrade 3").show()
										
		pu.set_pressed( status>=0 and i==game.get_value("current_powerup") )
		

	get_node("coins/number").set_number(game.get_cospels())



func _ready():
	get_node("main").connect("pressed", self, "back")
	get_node("play").connect("pressed", self, "play")
	get_node("store").connect("pressed", self, "store_pressed")
	
	for i in range(5):
		var pu = get_node("campo/pu "+str(i+1))
		pu.set_normal_texture(ResourceLoader.load("res://screens/gear_up/"+pu_names[i]+"_selected_black.png"))
		pu.set_pressed_texture(ResourceLoader.load("res://screens/gear_up/"+pu_names[i]+"_selected_red.png"))
		pu.set_disabled_texture(ResourceLoader.load("res://screens/gear_up/"+pu_names[i]+"_disabled.png"))
		powerups.push_back( pu )		
		pu.connect("pressed", self, "item_toggled", [i])
		pu.get_node("upgrade").connect("pressed", self, "upgrade_item", [i])

	game = get_scene().get_root().get_node("gamestate")

	var features = game.get_value("features")
	if ("powerup_unlock" in features and features["powerup_unlock"]):
		can_always_buy_powerups=true

	add_to_group("store_actions")

	get_node("coins/number").force_number(game.get_cospels())
	
	if (game.get_value("noblex_mode")):
		get_node("store").hide()
	
	update_status()


func _on_select_pressed():
	get_scene().call_group(0, "gear_up_actions", "gear_up_level_select")
	queue_free()
	pass # replace with function body
