
var store
var config = preload("res://config/game_config.gd")

var buttons = [null,null,null]
var prices = [0,0,0]

var game

var current_multiply = -1

func back_pressed():
	get_scene().call_group(0, "training_mode_actions", "training_mode_back")

func play_pressed():
	if (current_multiply>=0):
		game.set_cospels(game.get_cospels() - prices[current_multiply])
		game.save()
	get_scene().call_group(0, "training_mode_actions", "training_mode_done", [1,3,5,7][current_multiply+1])


func store_pressed():
	store = preload("res://screens/store.xml").instance()
	hide()
	get_scene().get_root().add_child(store)

func store_back():
	update_coins()
	show()
	store.queue_free()

func update_coins():
	var c = game.get_cospels()
	if (current_multiply>=0):
		c-=prices[current_multiply]
	get_node("coins").set_number(c)

func feature_toggled(pressed,idx):

	if (not pressed):
		current_multiply=-1
		update_coins()
		return
	
	for i in range(3):
		if (i !=idx ):
			buttons[i].set_pressed(false)
		else:
			var cc = game.get_cospels()
			if (cc < prices[i]):
				buttons[i].set_pressed(false)
				current_multiply=-1
				get_node("/root/global").popup_dialog(tr("NOTIFICATION_COINS_TITLE"),tr("NOTIFICATION_COINS"),tr("NOTIFICATION_COINS_STORE"),null,"",false)
			else:
				current_multiply=i
				
	update_coins()
				
func _ready():
	game = get_scene().get_root().get_node("gamestate")

	get_node("main").connect("pressed", self, "back_pressed")
	get_node("store").connect("pressed", self, "store_pressed")
	get_node("play").connect("pressed", self, "play_pressed")
	
	buttons = [get_node("group/x3"),get_node("group/x5"),get_node("group/x7")]
	prices = [
		config.training_mode_multiply_x3_price,
		config.training_mode_multiply_x5_price,
		config.training_mode_multiply_x7_price
	]


	get_node("group/x3").connect("toggled", self, "feature_toggled", [0])
	get_node("group/x5").connect("toggled", self, "feature_toggled", [1])
	get_node("group/x7").connect("toggled", self, "feature_toggled", [2])

	add_to_group("store_actions")

	get_node("coins").force_number(game.get_cospels())
	get_node("coins_x_3/price").set_text(str(prices[0]))
	get_node("coins_x_5/price").set_text(str(prices[1]))
	get_node("coins_x_7/price").set_text(str(prices[2]))
	
	if (game.get_value("noblex_mode")):
		get_node("store").hide()
	
	

