
var store
var game

var first = true

func update_sound():
	var sound_disabled = game.get_value("sound_disabled")
	if sound_disabled:
		AudioServer.set_fx_global_volume_scale(0)
		AudioServer.set_event_voice_global_volume_scale(0)
	else:
		AudioServer.set_fx_global_volume_scale(1)
		AudioServer.set_event_voice_global_volume_scale(1)

	var music_disabled = game.get_value("music_disabled")
	if music_disabled:
		AudioServer.set_stream_global_volume_scale(0)
	else:
		AudioServer.set_stream_global_volume_scale(1)


func _on_button_click():
	get_node("sfx").play("click")

func gameplay_begin():
#	get_node("stream").stop()
	pass

func gameplay_end():
#	get_node("stream").play()
	pass
	
func register_achievement(which):
	pass
		
func popup_dialog(title,subtitle,text,icon,close_cbk=null,close_fnc="",shine=true):
	get_node("dialog").popup_dialog(title,subtitle,text,icon,close_cbk,close_fnc,shine)

var current=null


func _find_buttons(node):

	for n in node.get_children():
		if (n extends BaseButton):
			n.connect("pressed",self,"_on_button_click")
		_find_buttons(n)

func _scene_loaded(res):
	var root = get_scene().get_root()
	var scene = res.instance()

	root.remove_child(current)
	current.free()
	current=null
	root.add_child(scene)
	root.move_child(scene, 0)
	_find_buttons(scene)
	current=scene


func _notification(what):
	print("NOTIF: ",what)
	if (what==MainLoop.NOTIFICATION_WM_QUIT_REQUEST):
		if (current):
			var b = current.get_node("back")
			if (not b):
				b=current.get_node("main")
			if (not b):
				b=current.get_node("home")	

			if (not b and current.get_child_count()>0):
				var c = current.get_child(0)
				b = c.get_node("back")
				if (not b):
					b=c.get_node("main")
				if (not b):
					b=c.get_node("home")	
				
			if (b and b.is_visible()):
				b.emit_signal("pressed")
				print("yes button")			
				


func change_scene(path):

	var root = get_scene().get_root()
	current = get_scene().get_root().get_child( 0 )
	if path == "":
		return
	get_node("loader").load_scene(path)
	
func _ready():
	get_node("loader").connect("loaded",self,"_scene_loaded")
	add_to_group("global")
	store = preload("res://screens/store.xml")
	game = get_scene().get_root().get_node("gamestate")
	update_sound()
	#stretch screen
	var vm = OS.get_video_mode_size()
	var rate = float(vm.x)/float(vm.y)
	var height = int(1024.0 / rate)
	get_scene().get_root().set_size_override(true,Vector2(1024,height))
	get_scene().get_root().set_size_override_stretch(true)
	get_scene().set_auto_accept_quit(false)
	get_parent().call_deferred("move_child",get_parent().get_child(get_parent().get_child_count()-1),0)
	



