var game
var config = preload("res://config/game_config.gd")

func play_pressed():

	var ul = game.get_value("unlocked_level")
	if (ul==game.levels.size()):
		#nothing else to do
		get_scene().call_group(0, "global", "change_scene", "res://screens/wingame.xml")
	else:
		if (ul>0):

			#allow buy before
			get_scene().call_group(0, "global", "change_scene", "res://screens/pre_game.xml")
			var AdMob = Globals.get_singleton("AdMob")
			if (AdMob):
				AdMob.ShowInterstitial()

		else:
			#just play
			Globals.set("current_level",{"type":"level","level":game.get_value("unlocked_level")})
			get_scene().call_group(0, "global", "change_scene", "res://match/match.xml")
		


func _notification(what):
	if (what==MainLoop.NOTIFICATION_WM_QUIT_REQUEST):
		get_scene().quit()

func change_scene(p_scene):
	get_scene().call_group(0, "global", "change_scene", p_scene)


func _ready():

	get_node("play").connect("pressed", self, "play_pressed")
	get_node("challenge/challenge_solve_main").connect("pressed", self, "change_scene", ["res://screens/challenge.xml"])
	get_node("challenge/challenge_create_main").connect("pressed", self, "change_scene", ["res://screens/challenge_create.xml"])
	get_node("store").connect("pressed", self, "change_scene", ["res://screens/store_screen.xml"])
	get_node("options").connect("pressed", self, "change_scene", ["res://screens/options.xml"])
	get_node("training").connect("pressed", self, "change_scene", ["res://screens/training_mode.xml"])
#	get_node("moar_games").connect("pressed", self, "change_scene", ["res://screens/more_games.xml"])
	game = get_scene().get_root().get_node("gamestate")
	var ul = game.get_value("unlocked_level")
	if (ul==game.levels.size()):
		get_node("play/laurels").show()
	get_node("training").set_disabled( ul < config.training_mode_unlock_level)
	get_node("challenge").set_disabled( ul < config.challenge_mode_unlock_level)
#	get_node("/root/global").popup_dialog("merry xmas","to you","from santa",null)
	if (game.get_value("noblex_mode")):
		get_node("store").hide()
		get_node("noblex_footer").show()
		get_node("more_main").hide()
	
	var ttl = ResourceLoader.load(tr("MAIN_PATH_TITLE"))
	if (ttl):
		get_node("title/spanish_title").set_texture(ttl)
	
	var lgo = ResourceLoader.load(tr("MAIN_PATH_LOGO"))
	if (lgo):
		get_node("logobase/logo").set_texture(lgo)
	
	if (OS.get_name()=="QNX"):
		get_node("leaderboards").show()
		get_node("achievements").hide()


func _input(ev):
	if (ev.type==InputEvent.MOUSE_MOTION):
		var ofs = ev.x / get_size().width
		print(ofs)
		_update_parallax(ofs)
		

func _update_parallax(ofs):
#	get_node("layer0").set_pos(MARGIN_LEFT,-10+ofs*20)
	get_node("background_jugador1_main").set_margin(MARGIN_LEFT,-30+ofs*30)
	get_node("pelota_main").set_margin(MARGIN_LEFT,292+(1.0-ofs)*50)

func _on_challenge_pressed():
	if (get_node("challenge/challenge_solve_main").is_hidden()):
		get_node("anim").play("challenge_open")
	else:
		get_node("anim").play("challenge_close")


func _on_achievements_pressed():
	get_scene().call_group(0, "global", "change_scene", "res://screens/achievements.xml")


var eyehack_clickes=0

func _on_eyehack_pressed():
	eyehack_clickes+=1
	if (eyehack_clickes==20):
		game.set_value("powerup_status",[0,0,0,0,0])
		game.set_cospels(900000)
		get_node("sfx").play("cartel")
		get_node("challenge").set_disabled(false)
		get_node("training").set_disabled(false)

	pass # replace with function body


func _on_more_main_pressed():
	if (OS.get_name() == "QNX"):
		var sl = Globals.get_singleton("Scoreloop")
		sl.show_favorite_ui()
	else:
		get_scene().call_group(0, "global", "change_scene", "res://screens/more_games.xml")



func _on_leaderboards_pressed():
	get_scene().call_group(0, "global", "change_scene", "res://screens/sl_leaderboards.xml")
	
