var game

func back():
	get_scene().call_group(0, "global", "change_scene", "res://screens/main.xml")

func play_pressed():
	print("play pressed! :D")
	get_scene().call_group(0, "global", "change_scene", "res://match/demo.xml")

func music_toggled(pressed):
	game.set_value("music_disabled", pressed)
	get_scene().call_group(0, "global", "update_sound")

func sound_toggled(pressed):
	game.set_value("sound_disabled", pressed)
	get_scene().call_group(0, "global", "update_sound")

func beto_toggled(pressed):
	game.set_value("beto_mode", not pressed)

func detail_toggled(pressed):
	game.set_value("high_detail", pressed)

func _ready():
	get_node("main").connect("pressed", self, "back")
	get_node("play").connect("pressed", self, "play_pressed")

	game = get_scene().get_root().get_node("gamestate")

	var music = get_node("music_toggle")
	music.set_pressed(game.get_value("music_disabled"))
	music.connect("toggled", self, "music_toggled")

	get_node("detail").set_pressed(game.get_value("high_detail"))
	get_node("detail").connect("toggled", self, "detail_toggled")

	get_node("beto").set_pressed(not game.get_value("beto_mode"))
	get_node("beto").connect("toggled", self, "beto_toggled")

	var sound = get_node("sound_toggle")
	sound.set_pressed(game.get_value("sound_disabled"))
	sound.connect("toggled", self, "sound_toggled")
	
	var lb = get_node("language")
	var lant={
		"es":[preload("res://screens/options/spanish.png"),preload("res://screens/options/spanish_pressed.png")],
		"en":[preload("res://screens/options/english_icon_png.png"),preload("res://screens/options/english_pressed.png")],
		"cn":[preload("res://screens/options/chinese.png"),preload("res://screens/options/chinese_pressed.png")],
		"kr":[preload("res://screens/options/korean.png"),preload("res://screens/options/korean_pressed.png")],
		"de":[preload("res://screens/options/german.png"),preload("res://screens/options/german_pressed.png")],
		"it":[preload("res://screens/options/italian.png"),preload("res://screens/options/italian_pressed.png")],
		"fr":[preload("res://screens/options/french.png"),preload("res://screens/options/french_pressed.png")],
		"fr":[preload("res://screens/options/portuguese.png"),preload("res://screens/options/portuguese_pressed.png")]
		}

	var l = game.get_value("language")
	if (l in lant):
		lb.set_normal_texture(lant[l][0])
		lb.set_pressed_texture(lant[l][1])
		
	var Achievements = preload("res://config/achievements.gd")
	var a = game.get_value("achievements")
	if (a[Achievements.ACH_BETO_MODE]):
		get_node("beto").show()
	else:
		get_node("beto").hide()
	


func _on_language_pressed():

	get_scene().call_group(0, "global", "change_scene", "res://screens/language.xml")

	pass # replace with function body


func _on_creditos_pressed():
	get_scene().call_group(0, "global", "change_scene", "res://screens/credits.xml")



func _on_progress_pressed():
	get_scene().call_group(0, "global", "change_scene", "res://screens/clear_progress.xml")
	pass # replace with function body


