
extends TextureFrame

var Scoreloop
# member variables here, example:
# var a=2
# var b="textvar"

const CHECK_INTERVAL = 1.0
var remaining=CHECK_INTERVAL

var vb = null


func _on_back_pressed():
	get_scene().call_group(0, "global", "change_scene", "res://screens/main.xml")


func _fill_list(ranks,users,scores):
	if (vb):
		vb.free()
	vb = VBoxContainer.new()
	get_node("list").add_child(vb)
		
	for i in range(ranks.size()):
		var rank = ranks[i]
		var user = users[i]
		var score = scores[i]
		var item = preload("res://screens/lb_item.xml").instance()
		item.get_node("rank").set_text(str(rank))
		item.get_node("name").set_text(str(user))
		item.get_node("score").set_text(str(score))
		vb.add_child(item)
	get_node("anim").play("loaded")        
		
		


func _process(delta):

	remaining-=delta
	if (remaining>0):
		return
	remaining=CHECK_INTERVAL
	
	while Scoreloop.get_pending_event_count() > 0:
		var event = Scoreloop.pop_pending_event()
		if event.type == "leaderboard":
			if event.result == "error":
				get_node("load").set_text("LEADERBOARD_ERROR")
				get_node("anim").play("error")
			elif event.result == "ok":
				get_node("anim").play("loaded")        
				_fill_list(event.ranks,event.users,event.scores)
					
		
	
	
	
func _ready():

	Scoreloop = Globals.get_singleton("Scoreloop")

	# Initalization here
	var ret = Scoreloop.load_leaderboard( { "mode": 0 } )
	if ret == OK:
		get_node("anim").play("loading")
		#print("load returned OK")
	else:
		get_node("anim").play("error")
		#print("load returned error ", ret)
	set_process(true)
	get_node("list").set_theme(preload("res://screens/scrolls.xml"))
	get_node("list").set_enable_h_scroll(false)
	#_fill_list([1,2,3,4,5],["Ariel","Maxi","Fer","Lucas","Martina"],[12345,234,23,2,0])
	if (OS.get_name()=="QNX"):
		get_node("scoreloop").show()
	pass
	




func _on_achievements_pressed():
	get_scene().call_group(0, "global", "change_scene", "res://screens/achievements.xml")
	pass # replace with function body
