var game
var config = preload("res://config/game_config.gd")
var InAppStore
var pkg_current = 0
var pkg_buttons = []

func back():
	get_scene().call_group(0, "store_actions", "store_back")

func get_store_package(pkg):
	var platform = OS.get_name()
	printt("looking for package ", pkg, platform)
	if !(platform in config.package_providers):
		return null
	if !(pkg in config.package_providers[platform]):
		print("can't find providers for package ", pkg)
		return null
	var prefix = Globals.get(platform+"/store_prefix")
	for p in config.package_providers[platform][pkg]:
		var name_full = prefix+p
		if name_full in game.get_value("store_packages_bought"):
			continue
		return name_full
	print("exhausted all packages?")
	return null

func get_game_package(pkg):
	var platform = OS.get_name()
	if !(platform in config.package_providers):
		return null
	var prefix = Globals.get(platform+"/store_prefix")
	for gpkg in config.package_providers[platform]:
		for p in config.package_providers[platform][gpkg]:
			if pkg == prefix+p:
				return gpkg
	return null #shit?

func buy_package(name):

	var platform = OS.get_name()
	if !(platform in config.package_providers):
		get_node("/root/global").popup_dialog("Store", "", "Error: not supported by platform.", null, null, "", false)
		return

	var pkg_id = get_store_package(name)
	if typeof(pkg_id) == typeof(null):
		get_node("/root/global").popup_dialog("STORE_ERROR_HEADER", "", "STORE_ERROR1", null, null, "", false)
		return

	var ret = InAppStore.purchase({ "product_id": pkg_id })
	if ret != OK:
		get_node("/root/global").popup_dialog("STORE_ERROR_HEADER", "", "STORE_ERROR2", null, null, "", false)
		return

	get_node("animation").play("busy")

func check_store():
	while InAppStore.get_pending_event_count():
		var event = InAppStore.pop_pending_event()
		if event.type == "product_info":
			if event.result != "ok":
				get_node("/root/global").popup_dialog("STORE_ERROR_HEADER", "", "Error loading products, please try again later.", null, null, "", false)
				return
			load_store_products(event)
		elif event.type == "purchase":
			if event.result != "ok":
				print("purchase error! ", event.product_id)
				get_node("animation").play("ready")
				get_node("/root/global").popup_dialog("STORE_ERROR_HEADER", "", "STORE_ERROR2", null, null, "", false)
				return
			_purchased(event.product_id)

func load_store_products(event):
	for i in range(event.titles):
		printt("got product ", event.titles[i], event.descriptions[i], event.prices[i], event.ids[i], event.localized_prices[i])

func _purchased(pkg_name):
	var pkg = get_game_package(pkg_name)
	for f in config.packages[pkg]:
		if typeof(f) == typeof(0):
			add_cospels(f)
		elif typeof(f) == typeof(""):
			game.get_value("features")[f] = true

	game.get_value("store_packages_bought").push_back(pkg_name)
	game.get_value("game_packages_bought").push_back(pkg)
	print("** ready")
	get_node("animation").play("ready")
	get_node("/root/global").popup_dialog("STORE_HEADER", "", "STORE_THANKS", null, null, "", false)
	game.save()


func add_cospels(n):
	game.set_cospels( game.get_cospels() + n )
	game.save()
	get_node("coins/number").set_number( game.get_cospels() )

		
func _update_packs():
	for i in range(5):
		#get_node("coin_container/cost "+str(i+1)).set_text( fake_usd_prices[i] )
		get_node("coin_container/item "+str(i+1)).set_text( str( config.get("coin_pack_"+str(i+1)+"_amount" ) ) )

func select_pkg(dir):
	pkg_current += dir
	if pkg_current < 0:
		pkg_current += pkg_buttons.size()
	if pkg_current >= pkg_buttons.size():
		pkg_current -= pkg_buttons.size()
	for i in range(pkg_buttons.size()):
		if i == pkg_current:
			pkg_buttons[i].show()
		else:
			pkg_buttons[i].hide()

	if pkg_buttons[pkg_current].package in game.get_value("game_packages_bought"):
		get_node("animation").play("package_locked")
	else:
		get_node("animation").play("package_available")

		
func _ready():
	game = get_scene().get_root().get_node("gamestate")
	get_node("main").connect("pressed", self, "back")
	for i in range(5):
		var but = get_node("coin_container/button "+str(i+1))
		but.connect("pressed",self,"buy_package",[but.package])
	get_node("coins/number").force_number( game.get_cospels() )
	#_update_packs()

	get_node("package_next").connect("pressed", self, "select_pkg", [1])
	get_node("package_prev").connect("pressed", self, "select_pkg", [-1])
	var packs = get_node("packs")
	for i in range(packs.get_child_count()):
		var c = packs.get_child(i)
		if !(c extends preload("res://screens/store/pack.gd")):
			continue
		pkg_buttons.push_back(c)
		c.connect("pressed", self, "buy_package", [c.package])

	select_pkg(0)

	if Globals.has_singleton("InAppStore"):
		InAppStore = Globals.get_singleton("InAppStore")
		var timer = get_node("timer")
		timer.connect("timeout", self, "check_store")
		timer.set_wait_time(1)
		timer.set_one_shot(false)
		timer.start()

